
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>


enum {
//    _xinfreq = 20_000_000,
    _xtlfreq = 20_000_000,
    _clkfreq = 200_000_000,
};



static struct test_parms_t {
    uint32_t  p_clk, p_dat, m_align, v_nco, m_se2, m_dat, m_crc, m_align2, v_crc;
} testset;


static void  set_params( void )
{
    testset.p_clk = 56;
    testset.p_dat = 57;
    testset.m_align = 0;
    testset.m_align2 = 0;
    testset.v_nco = 0;
    testset.m_se2 = 58;
    testset.m_dat = 59;
    testset.m_crc = 60;
    testset.v_crc = 61;
}


static void  tester( void )
{
    uint32_t t1,t2,t3,t4,t5,t6,t7,t8,t9;

    __asm volatile {    // "const" enforces XIP, "volatile" enforces Fcache
// retrieve parameter set
		loc	pa, #testset    // fast copy from struct
		setq	#sizeof(testset) / 4 - 1
		rdlong	rp_clk, pa    // fast copy to cogRAM

		mov	t1, rp_clk
		mov	t2, rp_dat
		mov	t3, rm_align
		mov	t4, rv_nco
		mov	t5, rm_se2
		mov	t6, rm_dat
		mov	t7, rm_crc
		mov	t8, rm_align2
		mov	t9, rv_crc

		ret

rp_clk		res 1
rp_dat		res 1
rm_align	res 1
rv_nco		res 1
rm_se2		res 1
rm_dat		res 1
rm_crc		res 1
rm_align2	res 1
rv_crc		res 1

    }

    printf(" t1 = %d\n", t1);
    printf(" t2 = %d\n", t2);
    printf(" t3 = %d\n", t3);
    printf(" t4 = %d\n", t4);
    printf(" t5 = %d\n", t5);
    printf(" t6 = %d\n", t6);
    printf(" t7 = %d\n", t7);
    printf(" t8 = %d\n", t8);
    printf(" t9 = %d\n", t9);

}



//===================================================================================

void  main( void )
{
    printf("   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), _clockmode());
    printf("  Compiled with FlexC v%s\n", __VERSION__);

    set_params();
    tester();
}
